﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace C1TrueDbGrid_CustomizedMultiSel
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'c1NWindDataSet.Customers' table. You can move, or remove it, as needed.
          this.customersTableAdapter.Fill(this.c1NWindDataSet.Customers);       
          c1TrueDBGrid1.RowColChange += new C1.Win.C1TrueDBGrid.RowColChangeEventHandler(c1TrueDBGrid1_RowColChange);
          c1TrueDBGrid1.SelChange += new C1.Win.C1TrueDBGrid.CancelEventHandler(c1TrueDBGrid1_SelChange);
        }

        //Cancel the Selection Change event as we are manually doing the selection
        void c1TrueDBGrid1_SelChange(object sender, C1.Win.C1TrueDBGrid.CancelEventArgs e)
        {
            e.Cancel = true;
        }

        //Multiple Selection code will be handled here based on ctrl or shift key
        void c1TrueDBGrid1_RowColChange(object sender, C1.Win.C1TrueDBGrid.RowColChangeEventArgs e)
        {
            int row = 0;

            //Control key is pressed : Add or delete the row from selection depending on whether the row is in SelectedRows Collection
            if (((Control.ModifierKeys & Keys.Control) != 0) && c1TrueDBGrid1.MultiSelect != C1.Win.C1TrueDBGrid.MultiSelectEnum.None)
            {
                if (c1TrueDBGrid1.SelectedRows.IndexOf(c1TrueDBGrid1.Row) > -1)
                {
                    c1TrueDBGrid1.SelectedRows.RemoveAt(c1TrueDBGrid1.SelectedRows.IndexOf(c1TrueDBGrid1.Row));
                }
                else
                {
                    c1TrueDBGrid1.SelectedRows.Add(c1TrueDBGrid1.Row);
                }
            }
            else //Shift key is pressed : selects all rows between the first selected row in selected row collection and the currently clicked row: 
            {
                if (((Control.ModifierKeys & Keys.Shift) != 0) && c1TrueDBGrid1.MultiSelect != C1.Win.C1TrueDBGrid.MultiSelectEnum.None)
                {

                    int SelRowStartindex = c1TrueDBGrid1.SelectedRows[0];
                    c1TrueDBGrid1.SelectedRows.Clear();
                    c1TrueDBGrid1.SelectedRows.Add(SelRowStartindex);
                    if (c1TrueDBGrid1.SelectedRows.Count > 0)
                    {
                        if (c1TrueDBGrid1.SelectedRows[0] > c1TrueDBGrid1.Row)
                        {
                            for (row = c1TrueDBGrid1.SelectedRows[0]; row >= c1TrueDBGrid1.Row; row += -1)
                            {
                                if (c1TrueDBGrid1.SelectedRows.IndexOf(row) > -1)
                                {
                                    c1TrueDBGrid1.SelectedRows.RemoveAt(c1TrueDBGrid1.SelectedRows.IndexOf(row));
                                }
                                c1TrueDBGrid1.SelectedRows.Add(row);
                            }
                        }
                        else
                        {
                            for (row = c1TrueDBGrid1.SelectedRows[0]; row <= c1TrueDBGrid1.Row; row++)
                            {
                                if (c1TrueDBGrid1.SelectedRows.IndexOf(row) > -1)
                                {
                                    c1TrueDBGrid1.SelectedRows.RemoveAt(c1TrueDBGrid1.SelectedRows.IndexOf(row));
                                }
                                c1TrueDBGrid1.SelectedRows.Add(row);
                            }
                        }
                    }
                }
                else
                {
                    c1TrueDBGrid1.SelectedRows.Clear();
                    c1TrueDBGrid1.SelectedRows.Add(c1TrueDBGrid1.Row);
                }
            }

        }


    }
}
